diff --git a/pyanaconda/packaging/livepayload.py b/pyanaconda/packaging/livepayload.py
index 03c464e..43f9871 100644
--- a/pyanaconda/packaging/livepayload.py
+++ b/pyanaconda/packaging/livepayload.py
@@ -33,7 +33,6 @@ import os
 import stat
 from time import sleep
 from threading import Lock
-from pyanaconda import isys
 
 from . import *
 
@@ -48,6 +47,7 @@ log = logging.getLogger("anaconda")
 from pyanaconda.errors import *
 from pyanaconda import progress
 from pyanaconda.storage.size import Size
+from pyanaconda.storage import util
 from pyanaconda.threads import threadMgr, AnacondaThread
 
 import gettext
@@ -64,7 +64,7 @@ class LiveImagePayload(ImagePayload):
             exn = PayloadSetupError("%s is not a valid block device" % (self.data.method.partition,))
             if errorHandler.cb(exn) == ERROR_RAISE:
                 raise exn
-        isys.mount(osimg.path, INSTALL_TREE, fstype="auto", readOnly=True)
+        util.mount(osimg.path, INSTALL_TREE, fstype="auto", options="ro")
 
     def preInstall(self, packages=None, groups=None):
         """ Perform pre-installation tasks. """
@@ -130,7 +130,7 @@ class LiveImagePayload(ImagePayload):
     def postInstall(self):
         """ Perform post-installation tasks. """
         progress.send_message(_("Performing post-install setup tasks"))
-        isys.umount(INSTALL_TREE, removeDir=True)
+        util.umount(INSTALL_TREE)
 
         super(LiveImagePayload, self).postInstall()
         self._recreateInitrds()
diff --git a/pyanaconda/packaging/yumpayload.py b/pyanaconda/packaging/yumpayload.py
index 4637210..43feebe 100644
--- a/pyanaconda/packaging/yumpayload.py
+++ b/pyanaconda/packaging/yumpayload.py
@@ -72,9 +72,10 @@ from pyanaconda.flags import flags
 
 from pyanaconda import iutil
 from pyanaconda.iutil import ProxyString, ProxyStringError
-from pyanaconda import isys
 from pyanaconda.network import hasActiveNetDev
 from pyanaconda.storage.size import Size
+from pyanaconda.storage import util
+from pyanaconda.storage import arch
 
 from pyanaconda.image import opticalInstallMedia
 from pyanaconda.image import mountImage
@@ -136,7 +137,7 @@ class YumPayload(PackagePayload):
                get_mount_device(INSTALL_TREE) == self.install_device.path:
                 self.install_device.teardown(recursive=True)
             else:
-                isys.umount(INSTALL_TREE, removeDir=False)
+                util.umount(INSTALL_TREE)
 
         if os.path.ismount(ISO_DIR) and not flags.testing:
             if self.install_device and \
@@ -149,7 +150,7 @@ class YumPayload(PackagePayload):
             # Commenting out the below is a hack for F18.  FIXME
             #else:
             #    # NFS
-            #    isys.umount(ISO_DIR, removeDir=False)
+            #    util.umount(ISO_DIR)
 
         self.install_device = None
 
@@ -647,17 +648,6 @@ reposdir=%s
                                            ["--make-rprivate", "/"])
                     iutil.execWithRedirect("mount",
                                            ["--move", INSTALL_TREE, ISO_DIR])
-                    # Mounts are kept track of in isys it seems
-                    # Remove the count for the source
-                    if isys.mountCount.has_key(INSTALL_TREE):
-                        if isys.mountCount[INSTALL_TREE] > 1:
-                            isys.mountCount[INSTALL_TREE] -= 1
-                        else:
-                            del(isys.mountCount[INSTALL_TREE])
-                    # Add a count for the new location
-                    if not isys.mountCount.has_key(ISO_DIR):
-                        isys.mountCount[ISO_DIR] = 0
-                    isys.mountCount[ISO_DIR] += 1
                     # mount the ISO on a loop
                     image = os.path.normpath("%s/%s" % (ISO_DIR, image))
                     mountImage(image, INSTALL_TREE)
@@ -845,7 +835,7 @@ reposdir=%s
 
         if mountpoint and os.path.ismount(mountpoint):
             try:
-                isys.umount(mountpoint, removeDir=False)
+                util.umount(mountpoint, removeDir=False)
             except SystemError as e:
                 log.error("failed to unmount nfs repo %s: %s" % (mountpoint, e))
 
@@ -1512,7 +1502,7 @@ class RPMCallback(object):
 
         self.total_actions = 0
         self.completed_actions = None   # will be set to 0 when starting tx
-        self.base_arch = iutil.getArch()
+        self.base_arch = arch.getArch()
 
     def _get_txmbr(self, key):
         """ Return a (name, TransactionMember) tuple from cb key. """
diff --git a/pyanaconda/platform.py b/pyanaconda/platform.py
index b1c849b..2012cdb 100644
--- a/pyanaconda/platform.py
+++ b/pyanaconda/platform.py
@@ -26,10 +26,8 @@ log = logging.getLogger("anaconda")
 import parted
 
 from pyanaconda import bootloader
-from pyanaconda.storage.devicelibs import mdraid
-from pyanaconda.constants import DMI_CHASSIS_VENDOR
+from pyanaconda.storage import arch
 
-import iutil
 from flags import flags
 
 import gettext
@@ -233,7 +231,7 @@ class MacEFI(EFI):
         return ret
 
 class PPC(Platform):
-    _ppcMachine = iutil.getPPCMachine()
+    _ppcMachine = arch.getPPCMachine()
     bootloaderClass = bootloader.GRUB2
     _boot_stage1_device_types = ["partition"]
 
@@ -347,7 +345,7 @@ class ARM(Platform):
     @property
     def armMachine(self):
         if not self._armMachine:
-            self._armMachine = iutil.getARMMachine()
+            self._armMachine = arch.getARMMachine()
         return self._armMachine
 
     def weight(self, fstype=None, mountpoint=None):
@@ -393,10 +391,10 @@ def getPlatform():
     """Check the architecture of the system and return an instance of a
        Platform subclass to match.  If the architecture could not be determined,
        raise an exception."""
-    if iutil.isPPC():
-        ppcMachine = iutil.getPPCMachine()
+    if arch.isPPC():
+        ppcMachine = arch.getPPCMachine()
 
-        if (ppcMachine == "PMac" and iutil.getPPCMacGen() == "NewWorld"):
+        if (ppcMachine == "PMac" and arch.getPPCMacGen() == "NewWorld"):
             return NewWorldPPC()
         elif ppcMachine in ["iSeries", "pSeries"]:
             return IPSeriesPPC()
@@ -404,19 +402,19 @@ def getPlatform():
             return PS3()
         else:
             raise SystemError, "Unsupported PPC machine type: %s" % ppcMachine
-    elif iutil.isS390():
+    elif arch.isS390():
         return S390()
-    elif iutil.isSparc():
+    elif arch.isSparc():
         return Sparc()
-    elif iutil.isEfi():
-        if iutil.isMactel():
+    elif arch.isEfi():
+        if arch.isMactel():
             return MacEFI()
         else:
             return EFI()
-    elif iutil.isX86():
+    elif arch.isX86():
         return X86()
-    elif iutil.isARM():
-        armMachine = iutil.getARMMachine()
+    elif arch.isARM():
+        armMachine = arch.getARMMachine()
         if armMachine == "omap":
             return omapARM()
         else:
diff --git a/pyanaconda/storage/__init__.py b/pyanaconda/storage/__init__.py
index 9d3af87..94f6263 100644
--- a/pyanaconda/storage/__init__.py
+++ b/pyanaconda/storage/__init__.py
@@ -31,16 +31,13 @@ import copy
 import nss.nss
 import parted
 
-from pyanaconda import isys
-from pyanaconda import iutil
 from pyanaconda.constants import *
 from pykickstart.constants import *
-from pyanaconda.flags import flags
 from pyanaconda import tsort
 from pyanaconda.errors import *
 from pyanaconda.bootloader import BootLoaderError
-from pyanaconda.anaconda_log import log_method_call
 
+from storage_log import log_method_call
 from errors import *
 from devices import *
 from devicetree import DeviceTree
@@ -63,6 +60,14 @@ import iscsi
 import fcoe
 import zfcp
 import dasd
+import util
+import arch
+import flags
+
+if flags.installer_mode:
+    from pyanaconda import isys
+else:
+    isys = None
 
 import shelve
 import contextlib
@@ -123,7 +128,7 @@ def storageInitialize(storage, ksdata, protected):
 
     # XXX I don't understand why I have to do this, but this is needed to
     #     populate the udev db
-    iutil.execWithRedirect("udevadm", ["control", "--property=ANACONDA=1"])
+    util.run_program(["udevadm", "control", "--property=ANACONDA=1"])
     udev_trigger(subsystem="block", action="change")
 
     # Before we set up the storage system, we need to know which disks to
@@ -137,30 +142,24 @@ def storageInitialize(storage, ksdata, protected):
         storage.config.protectedDevSpecs.extend(protected)
         storage.reset()
 
-        if not flags.livecdInstall and not storage.protectedDevices:
-            if anaconda.upgrade:
-                return
-            else:
-                raise UnknownSourceDeviceError(protected)
+        if not flags.live_install and not storage.protectedDevices:
+            raise UnknownSourceDeviceError(protected)
     else:
         storage.reset()
 
     # kickstart uses all the disks
-    if flags.automatedInstall:
+    if flags.automated_install:
         if not ksdata.ignoredisk.onlyuse:
             ksdata.ignoredisk.onlyuse = [d.name for d in storage.disks \
                                          if d.name not in ksdata.ignoredisk.ignoredisk]
             log.debug("onlyuse is now: %s" % (",".join(ksdata.ignoredisk.onlyuse)))
 
 def turnOnFilesystems(storage):
-    upgrade = "preupgrade" in flags.cmdline
-
-    if not upgrade:
-        if (flags.livecdInstall and not flags.imageInstall and not storage.fsset.active):
-            # turn off any swaps that we didn't turn on
-            # needed for live installs
-            iutil.execWithRedirect("swapoff", ["-a"])
-        storage.devicetree.teardownAll()
+    if (flags.live_install and not flags.image_install and not storage.fsset.active):
+        # turn off any swaps that we didn't turn on
+        # needed for live installs
+        util.run_program(["swapoff", "-a"])
+    storage.devicetree.teardownAll()
 
     try:
         storage.doIt()
@@ -394,7 +393,7 @@ class Storage(object):
         if self.data:
             self.config.update(self.data)
 
-        if not flags.imageInstall:
+        if not flags.image_install:
             self.iscsi.startup()
             self.fcoe.startup()
             self.zfcp.startup()
@@ -402,9 +401,6 @@ class Storage(object):
                               self.config.exclusiveDisks,
                               self.config.initializeDisks)
         clearPartType = self.config.clearPartType # save this before overriding it
-        if self.data and self.data.upgrade.upgrade:
-            self.config.clearPartType = CLEARPART_TYPE_NONE
-
         if self.dasd:
             # Reset the internal dasd list (823534)
             self.dasd.clear_device_list()
@@ -1300,7 +1296,7 @@ class Storage(object):
         else:
             template = prefix
 
-        if flags.imageInstall:
+        if flags.image_install:
             template = "%s_image" % template
 
         names = self.names
@@ -1429,11 +1425,14 @@ class Storage(object):
             a really small /, etc).  Returns (errors, warnings) where
             each is a list of strings.
         """
-        checkSizes = [('/usr', 250), ('/tmp', 50), ('/var', 384),
-                      ('/home', 100), ('/boot', 75)]
         warnings = []
         errors = []
 
+        if not flags.installer_mode:
+            return (errors, warnings)
+
+        checkSizes = [('/usr', 250), ('/tmp', 50), ('/var', 384),
+                      ('/home', 100), ('/boot', 75)]
         mustbeonlinuxfs = ['/', '/var', '/tmp', '/usr', '/home', '/usr/share', '/usr/lib']
         mustbeonroot = ['/bin','/dev','/sbin','/etc','/lib','/root', '/mnt', 'lost+found', '/proc']
 
@@ -1462,7 +1461,7 @@ class Storage(object):
         # restricted to a single PV.  The backend support is there, but there are
         # no UI hook-ups to drive that functionality, but I do not personally
         # care.  --dcantrell
-        if iutil.isS390() and \
+        if arch.isS390() and \
            not self.mountpoints.has_key('/boot') and \
            root.type == 'lvmlv' and not root.singlePV:
             errors.append(_("This platform requires /boot on a dedicated "
@@ -1494,9 +1493,11 @@ class Storage(object):
                               % {"mount":mount, "format": device.format.name,
                                  "minSize": device.minSize, "maxSize": device.maxSize})
 
+        # FIXME: this does not work, but probably should
+        """
         usb_disks = []
         firewire_disks = []
-        for disk in self.disks:
+        #for disk in self.disks:
             if isys.driveUsesModule(disk.name, ["usb-storage", "ub"]):
                 usb_disks.append(disk)
             elif isys.driveUsesModule(disk.name, ["sbp2", "firewire-sbp2"]):
@@ -1521,6 +1522,7 @@ class Storage(object):
         if uses_firewire:
             warnings.append(_("Installing on a FireWire device.  This may "
                               "or may not produce a working system."))
+        """
 
         if self.bootloader and not self.bootloader.skip_bootloader:
             stage1 = self.bootloader.stage1_device
@@ -1564,7 +1566,7 @@ class Storage(object):
         if not swaps:
             from pyanaconda.storage.size import Size
 
-            installed = Size(spec="%s kb" % iutil.memInstalled())
+            installed = Size(spec="%s kb" % util.total_memory())
             required = Size(spec="%s kb" % isys.EARLY_SWAP_RAM)
 
             if installed < required:
@@ -1820,7 +1822,7 @@ class Storage(object):
         elif mountpoint == "/boot":
             fstype = self.defaultBootFSType
         elif mountpoint == "/boot/efi":
-            if iutil.isMactel():
+            if arch.isMactel():
                 fstype = "hfs+"
             else:
                 fstype = "efi"
@@ -2354,10 +2356,10 @@ def mountExistingSystem(fsset, rootDevice,
         readOnly = ""
 
     if rootDevice.protected and os.path.ismount("/mnt/install/isodir"):
-        isys.mount("/mnt/install/isodir",
+        util.mount("/mnt/install/isodir",
                    rootPath,
                    fstype=rootDevice.format.type,
-                   bindMount=True)
+                   options="bind")
     else:
         rootDevice.setup()
         rootDevice.format.mount(chroot=rootPath,
@@ -2979,9 +2981,9 @@ class FSSet(object):
             f.close()
         else:
             log.info("not writing out mpath configuration")
-        iutil.copy_to_sysimage("/etc/multipath/wwids")
+        util.copy_to_system("/etc/multipath/wwids")
         if self.devicetree.mpathFriendlyNames:
-            iutil.copy_to_sysimage("/etc/multipath/bindings")
+            util.copy_to_system("/etc/multipath/bindings")
 
     def crypttab(self):
         # if we are upgrading, do we want to update crypttab?
@@ -3125,7 +3127,7 @@ def getReleaseString():
     relVer = None
 
     try:
-        relArch = iutil.execWithCapture("arch", [], root=ROOT_PATH).strip()
+        relArch = util.capture_output(["arch"], root=ROOT_PATH).strip()
     except:
         relArch = None
 
@@ -3149,7 +3151,7 @@ def getReleaseString():
 
 def findExistingInstallations(devicetree):
     if not os.path.exists(ROOT_PATH):
-        iutil.mkdirChain(ROOT_PATH)
+        util.makedirs(ROOT_PATH)
 
     roots = []
     for device in devicetree.leaves:
diff --git a/pyanaconda/storage/arch.py b/pyanaconda/storage/arch.py
new file mode 100644
index 0000000..7fc39e7
--- /dev/null
+++ b/pyanaconda/storage/arch.py
@@ -0,0 +1,315 @@
+#
+# arch.py
+#
+# Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2013
+# Red Hat, Inc.  All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+# Author(s): Jeremy Katz <katzj@redhat.com>
+#            Paul Nasrat <pnasrat@redhat.com>
+#            Peter Jones <pjones@redhat.com>
+#            Chris Lumens <clumens@redhat.com>
+#            Will Woods <wwoods@redhat.com>
+#            Dennis Gilmore <dgilmore@ausil.us>
+#            David Marlin <dmarlin@redhat.com>
+#
+
+import os
+
+from .flags import flags
+
+## Get the SPARC machine variety type.
+# @return The SPARC machine type, or 0 if not SPARC.
+def getSparcMachine():
+    if not isSparc():
+        return 0
+
+    machine = None
+
+
+    f = open('/proc/cpuinfo', 'r')
+    lines = f.readlines()
+    f.close()
+    for line in lines:
+        if line.find('type') != -1:
+            machine = line.split(':')[1].strip()
+            return machine
+
+    return None
+
+## Get the PPC machine variety type.
+# @return The PPC machine type, or 0 if not PPC.
+def getPPCMachine():
+    if not isPPC():
+        return 0
+
+    ppcMachine = None
+    machine = None
+    platform = None
+
+    # ppc machine hash
+    ppcType = { 'Mac'      : 'PMac',
+                'Book'     : 'PMac',
+                'CHRP IBM' : 'pSeries',
+                'Pegasos'  : 'Pegasos',
+                'Efika'    : 'Efika',
+                'iSeries'  : 'iSeries',
+                'pSeries'  : 'pSeries',
+                'PReP'     : 'PReP',
+                'CHRP'     : 'pSeries',
+                'Amiga'    : 'APUS',
+                'Gemini'   : 'Gemini',
+                'Shiner'   : 'ANS',
+                'BRIQ'     : 'BRIQ',
+                'Teron'    : 'Teron',
+                'AmigaOne' : 'Teron',
+                'Maple'    : 'pSeries',
+                'Cell'     : 'pSeries',
+                'Momentum' : 'pSeries',
+                'PS3'      : 'PS3',
+                'PowerNV'  : 'pSeries'
+                }
+
+    f = open('/proc/cpuinfo', 'r')
+    lines = f.readlines()
+    f.close()
+    for line in lines:
+        if line.find('machine') != -1:
+            machine = line.split(':')[1]
+        elif line.find('platform') != -1:
+            platform = line.split(':')[1]
+
+    for part in (machine, platform):
+        if ppcMachine is None and part is not None:
+            for type in ppcType.items():
+                if part.find(type[0]) != -1:
+                    ppcMachine = type[1]
+
+    if ppcMachine is None:
+        log.warning("Unable to find PowerPC machine type")
+    elif ppcMachine == 0:
+        log.warning("Unknown PowerPC machine type: %s" %(ppcMachine,))
+
+    return ppcMachine
+
+## Get the powermac machine ID.
+# @return The powermac machine id, or 0 if not PPC.
+def getPPCMacID():
+    machine = None
+
+    if not isPPC():
+        return 0
+    if getPPCMachine() != "PMac":
+        return 0
+
+    f = open('/proc/cpuinfo', 'r')
+    lines = f.readlines()
+    f.close()
+    for line in lines:
+      if line.find('machine') != -1:
+        machine = line.split(':')[1]
+        machine = machine.strip()
+        return machine
+
+    log.warning("No Power Mac machine id")
+    return 0
+
+## Get the powermac generation.
+# @return The powermac generation, or 0 if not powermac.
+def getPPCMacGen():
+    # XXX: should NuBus be here?
+    pmacGen = ['OldWorld', 'NewWorld', 'NuBus']
+
+    if not isPPC():
+        return 0
+    if getPPCMachine() != "PMac":
+        return 0
+
+    f = open('/proc/cpuinfo', 'r')
+    lines = f.readlines()
+    f.close()
+    gen = None
+    for line in lines:
+      if line.find('pmac-generation') != -1:
+        gen = line.split(':')[1]
+        break
+
+    if gen is None:
+        log.warning("Unable to find pmac-generation")
+
+    for _type in pmacGen:
+      if _type in gen:
+          return type
+
+    log.warning("Unknown Power Mac generation: %s" %(gen,))
+    return 0
+
+## Determine if the hardware is an iBook or PowerBook
+# @return 1 if so, 0 otherwise.
+def getPPCMacBook():
+    if not isPPC():
+        return 0
+    if getPPCMachine() != "PMac":
+        return 0
+
+    f = open('/proc/cpuinfo', 'r')
+    buf = f.read()
+    f.close()
+    return 'book' in buf.lower()
+
+## Get the ARM processor variety.
+# @return The ARM processor variety type, or 0 if not ARM.
+def getARMMachine():
+    if not isARM():
+        return 0
+
+    if flags.arm_platform:
+        return flags.arm_platform
+
+    armMachine = os.uname()[2].rpartition('.' )[2]
+
+    if armMachine.startswith('arm'):
+        return None
+    else:
+        return armMachine
+
+
+cell = None
+## Determine if the hardware is the Cell platform.
+# @return True if so, False otherwise.
+def isCell():
+    global cell
+    if cell is not None:
+        return cell
+
+    cell = False
+    if not isPPC():
+        return cell
+
+    f = open('/proc/cpuinfo', 'r')
+    lines = f.readlines()
+    f.close()
+
+    for line in lines:
+      if 'Cell' in line:
+          cell = True
+
+    return cell
+
+mactel = None
+## Determine if the hardware is an Intel-based Apple Mac.
+# @return True if so, False otherwise.
+def isMactel():
+    global mactel
+    if mactel is not None:
+        return mactel
+
+    if not isX86():
+        mactel = False
+    elif not os.path.isfile(DMI_CHASSIS_VENDOR):
+        mactel = False
+    else:
+        buf = open(DMI_CHASSIS_VENDOR).read()
+        mactel = ("apple" in buf.lower())
+    return mactel
+
+efi = None
+## Determine if the hardware supports EFI.
+# @return True if so, False otherwise.
+def isEfi():
+    global efi
+    if efi is not None:
+        return efi
+
+    efi = False
+    # XXX need to make sure efivars is loaded...
+    if os.path.exists("/sys/firmware/efi"):
+        efi = True
+
+    return efi
+
+# Architecture checking functions
+
+def isX86(bits=None):
+    arch = os.uname()[4]
+
+    # x86 platforms include:
+    #     i*86
+    #     athlon*
+    #     x86_64
+    #     amd*
+    #     ia32e
+    if bits is None:
+        if (arch.startswith('i') and arch.endswith('86')) or \
+           arch.startswith('athlon') or arch.startswith('amd') or \
+           arch == 'x86_64' or arch == 'ia32e':
+            return True
+    elif bits == 32:
+        if arch.startswith('i') and arch.endswith('86'):
+            return True
+    elif bits == 64:
+        if arch.startswith('athlon') or arch.startswith('amd') or \
+           arch == 'x86_64' or arch == 'ia32e':
+            return True
+
+    return False
+
+def isPPC(bits=None):
+    arch = os.uname()[4]
+
+    if bits is None:
+        if arch == 'ppc' or arch == 'ppc64':
+            return True
+    elif bits == 32:
+        if arch == 'ppc':
+            return True
+    elif bits == 64:
+        if arch == 'ppc64':
+            return True
+
+    return False
+
+def isS390():
+    return os.uname()[4].startswith('s390')
+
+def isIA64():
+    return os.uname()[4] == 'ia64'
+
+def isAlpha():
+    return os.uname()[4].startswith('alpha')
+
+def isSparc():
+    return os.uname()[4].startswith('sparc')
+
+def isARM():
+    return os.uname()[4].startswith('arm')
+
+def getArch():
+    if isX86(bits=32):
+        return 'i386'
+    elif isX86(bits=64):
+        return 'x86_64'
+    elif isPPC(bits=32):
+        return 'ppc'
+    elif isPPC(bits=64):
+        return 'ppc64'
+    elif isAlpha():
+        return 'alpha'
+    elif isSparc():
+        return 'sparc'
+    elif isARM():
+        return 'arm'
+    else:
+        return os.uname()[4]
diff --git a/pyanaconda/storage/dasd.py b/pyanaconda/storage/dasd.py
index 6c583cb..752ca05 100644
--- a/pyanaconda/storage/dasd.py
+++ b/pyanaconda/storage/dasd.py
@@ -19,17 +19,17 @@
 # Red Hat Author(s): David Cantrell <dcantrell@redhat.com>
 #
 
-from pyanaconda import iutil
 import sys
 import os
 from pyanaconda.storage.errors import DasdFormatError
 from pyanaconda.storage.devices import deviceNameToDiskByPath
+from pyanaconda.storage import util
+from pyanaconda.storage import arch
 from pyanaconda.constants import *
-from pyanaconda.flags import flags
 from pyanaconda.baseudev import udev_trigger
 
 import logging
-log = logging.getLogger("anaconda")
+log = logging.getLogger("storage")
 
 import gettext
 _ = lambda x: gettext.ldgettext("anaconda", x)
@@ -82,7 +82,7 @@ class DASD:
 
         self.started = True
 
-        if not iutil.isS390():
+        if not arch.isS390():
             return
 
         # Trigger udev data about the dasd devices on the system
@@ -140,8 +140,7 @@ class DASD:
         # gather total cylinder count
         argv = ["-t", "-v"] + self.commonArgv
         for dasd, bypath in self._dasdlist:
-            buf = iutil.execWithCapture(self.dasdfmt, argv + ["/dev/" + dasd],
-                                        stderr=err)
+            buf = util.capture_output([self.dasdfmt, argv, "/dev/" + dasd])
             for line in buf.splitlines():
                 if line.startswith("Drive Geometry: "):
                     # line will look like this:
@@ -169,18 +168,7 @@ class DASD:
             arglist = argv + ["/dev/" + dasd]
 
             try:
-                if intf and self.totalCylinders:
-                    ret = iutil.execWithCallback(self.dasdfmt, arglist,
-                                                 callback=update,
-                                                 callback_data=pw,
-                                                 echo=False)
-                    rc = ret.rc
-                elif intf:
-                    ret = iutil.execWithPulseProgress(self.dasdfmt, arglist,
-                                                      progress=pw)
-                    rc = ret.rc
-                else:
-                    rc = iutil.execWithRedirect(self.dasdfmt, arglist)
+                rc = util.run_program([self.dasdfmt] + arglist)
             except Exception as e:
                 raise DasdFormatError(e, bypath)
 
diff --git a/pyanaconda/storage/devicelibs/btrfs.py b/pyanaconda/storage/devicelibs/btrfs.py
index b6d0e54..a6b69e3 100644
--- a/pyanaconda/storage/devicelibs/btrfs.py
+++ b/pyanaconda/storage/devicelibs/btrfs.py
@@ -23,7 +23,7 @@
 import os
 import re
 
-from pyanaconda import iutil
+from .. import util
 from ..errors import *
 
 import gettext
@@ -33,13 +33,14 @@ import logging
 log = logging.getLogger("storage")
 
 def btrfs(args, capture=False):
-    kwargs = {}
     if capture:
-        exec_func = iutil.execWithCapture
+        exec_func = util.capture_output
     else:
-        exec_func = iutil.execWithRedirect
+        exec_func = util.run_program
 
-    ret = exec_func("btrfs", args, **kwargs)
+    argv = ["btrfs"] + args
+
+    ret = exec_func(argv)
     if ret and not capture:
         raise BTRFSError(ret)
     return ret
@@ -63,7 +64,7 @@ def create_volume(devices, label=None, data=None, metadata=None):
 
     args.extend(devices)
 
-    ret = iutil.execWithRedirect("mkfs.btrfs", args)
+    ret = util.run_program(["mkfs.btrfs"] + args)
     if ret:
         raise BTRFSError(ret)
 
diff --git a/pyanaconda/storage/devicelibs/crypto.py b/pyanaconda/storage/devicelibs/crypto.py
index 92a22a8..2a41cdd 100644
--- a/pyanaconda/storage/devicelibs/crypto.py
+++ b/pyanaconda/storage/devicelibs/crypto.py
@@ -22,7 +22,6 @@
 
 import os
 from pycryptsetup import CryptSetup
-from pyanaconda import iutil
 
 from ..errors import *
 
diff --git a/pyanaconda/storage/devicelibs/dm.py b/pyanaconda/storage/devicelibs/dm.py
index b451890..e7adfec 100644
--- a/pyanaconda/storage/devicelibs/dm.py
+++ b/pyanaconda/storage/devicelibs/dm.py
@@ -23,7 +23,7 @@
 import os
 
 import block
-from pyanaconda import iutil
+from .. import util
 from ..errors import *
 
 import gettext
@@ -33,25 +33,18 @@ import logging
 log = logging.getLogger("storage")
 
 def dm_setup(args):
-    ret = iutil.execWithRedirect("dmsetup", args)
+    ret = util.run_program(["dmsetup"] + args)
     if ret:
-        raise DMError(ret.stderr)
+        raise DMError("Failed to run dmsetup %s" % " ".join(args))
 
 def dm_create_linear(map_name, device, length, uuid):
     table = "0 %d linear %s 0" % (length, device)
     args = ["create", map_name, "--uuid", uuid, "--table", "%s" % table]
-    try:
-        dm_setup(args)
-    except DMError as msg:
-        raise DMError("dm_create_linear (%s, %d, %s) failed: %s"
-                                % (map_name, length, device, msg))
+    dm_setup(args)
 
 def dm_remove(map_name):
     args = ["remove", map_name]
-    try:
-        dm_setup(args)
-    except DMError as msg:
-        raise DMError("dm_remove (%s) failed: %s" % (map_name, msg))
+    dm_setup(args)
 
 def name_from_dm_node(dm_node):
     # first, try sysfs
diff --git a/pyanaconda/storage/devicelibs/loop.py b/pyanaconda/storage/devicelibs/loop.py
index 92b3444..8a4750c 100644
--- a/pyanaconda/storage/devicelibs/loop.py
+++ b/pyanaconda/storage/devicelibs/loop.py
@@ -22,7 +22,7 @@
 
 import os
 
-from pyanaconda import iutil
+from .. import util
 from ..errors import *
 
 import gettext
@@ -34,15 +34,15 @@ log = logging.getLogger("storage")
 
 def losetup(args, capture=False):
     if capture:
-        exec_func = iutil.execWithCapture
+        exec_func = util.capture_output
     else:
-        exec_func = iutil.execWithRedirect
+        exec_func = util.run_program
 
     try:
         # ask losetup what this loop device's backing device is
-        ret = exec_func("losetup", args)
-    except RuntimeError as e:
-        raise LoopError(str(e))
+        ret = exec_func(["losetup"] + args)
+    except OSError as e:
+        raise LoopError(e.strerror)
 
     return ret
 
